/*
 * com.simulogic.cese -- Cell Electrophysiology Simulation Environment (CESE)
 *
 * Copyright (C) 1999 - 2005 Sergey Missan
 * 
 * Dalhousie Univ., Halifax, NS, Canada
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

package com.simulogic.cese.properties;

import java.awt.Component;

import javax.swing.AbstractCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.table.TableCellEditor;

/**
 * An editor for types which have a property editor.
 */
public class PropertyClampEditor extends AbstractCellEditor implements
        TableCellEditor {

    private ClampAttribute clamp;
    private JCheckBox chb;

    /**
     * Default constructor
     */
    public PropertyClampEditor() {
        chb = new JCheckBox();
        chb.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chbCheckBoxActionPerformed();
            }
        });
    }

    /**
     * Get UI for current editor.
     */
    public Component getTableCellEditorComponent(JTable table, Object value,
            boolean isSelected, int row, int column) {

        clamp = (ClampAttribute) value;

        chb.setText(clamp.getVariable());
        chb.setSelected(clamp.isClamped());

        return chb;
    }

    /**
     * Get cellEditorValue for current editor
     */
    public Object getCellEditorValue() {
        return new ClampAttribute(chb.getText(), chb.isSelected());

    }

    private void chbCheckBoxActionPerformed() {
        stopCellEditing();
    }
}